Annotation of elwix/build_3thparty.sh, revision 1.6.2.4

1.2       misho       1: #!/bin/sh
                      2: #
                      3: # ELWIX build script for cross compiling 3th party software
                      4: #
                      5: # (C) AITNET ltd - Sofia/Bulgaria <office@aitnet.org>
                      6: #    by Michael Pounov <misho@elwix.org>
                      7: #
1.6.2.4 ! misho       8: # $Id: build_3thparty.sh,v 1.6.2.3 2017/10/08 10:23:40 misho Exp $
1.2       misho       9: #
                     10: 
                     11: [ -r ./config/rc.elwix ] && . ./config/rc.elwix
1.5       misho      12: if [ ! -r ./config/rc.3thparty_helper ]; then
                     13:        echo
                     14:        echo "ELWIX project is not configured - Missing rc.3thparty_helper script"
                     15:        echo
                     16:        exit 1
                     17: fi
                     18: 
1.2       misho      19: if [ X"${ELWIX_IS_CONFIGURED}" != X"YES" ]; then
                     20:        echo
                     21:        echo "ELWIX project is not configured !?!"
                     22:        echo
                     23:        exit 1
                     24: fi
                     25: V=${VERSION}
                     26: [ -r ${CENV} ] && . ${CENV}
                     27: unset INSTALL
                     28: unset VERSION
                     29: VERSION="$V"
                     30: 
                     31: if [ ! -d $BSDSRC ]; then
                     32:        echo
                     33:        echo "ELWIX project is not configured - missing BSD sources !?!"
                     34:        echo
                     35:        exit 1
                     36: fi
                     37: 
                     38: if [ ! -d $DEST ]; then
                     39:        echo
                     40:        echo "ELWIX project is not configured - missing Dest directory !?!"
                     41:        echo
                     42:        exit 1
                     43: fi
                     44: 
                     45: clean_3th()
                     46: {
1.6       misho      47:        echo "+++ Clean ELWIX 3th party ... ${PKG}, ${ROMFS_USR2}"
1.2       misho      48: 
1.3       misho      49:        rm -rf ${PKG} ${ROMFS_USR2}
                     50: 
1.2       misho      51:        install -d ${PKG}
                     52:        install -d ${PKG}/bin
                     53:        install -d ${PKG}/etc
                     54:        install -d ${PKG}/include
                     55:        install -d ${PKG}/man
                     56:        install -d ${PKG}/lib
                     57:        install -d ${PKG}/libexec
                     58:        install -d ${PKG}/sbin
1.3       misho      59: 
                     60:        install -d ${ROMFS_USR2}
                     61:        install -d ${ROMFS_USR2}/bin
                     62:        install -d ${ROMFS_USR2}/etc
                     63:        install -d ${ROMFS_USR2}/lib
                     64:        install -d ${ROMFS_USR2}/libexec
                     65:        install -d ${ROMFS_USR2}/sbin
1.2       misho      66: }
                     67: 
                     68: compile_3th()
                     69: {
                     70:        echo "+++ Compile ELWIX 3th party ..."
                     71: 
1.5       misho      72:        BUILD_SH="./config/rc.3thparty_helper"
                     73: 
1.6       misho      74: #      ${BUILD_SH} expat ${CBUILD} ${PKG} ${TARGET_BUILD}
                     75: #      [ $? -ne 0 ] && exit 1
                     76: #      ${BUILD_SH} libevent ${CBUILD} ${PKG} ${TARGET_BUILD}
                     77: #      [ $? -ne 0 ] && exit 1
                     78: #      ${BUILD_SH} libiconv ${CGBUILD} ${PKG} ${TARGET_BUILD}
                     79: #      [ $? -ne 0 ] && exit 1
                     80: #      ${BUILD_SH} pcre ${CBUILD} ${PKG} ${TARGET_BUILD}
                     81: #      [ $? -ne 0 ] && exit 1
                     82: 
1.6.2.4 ! misho      83:        for i in ${CROSS_3THPARTY}; do
        !            84:                if [ -d "${CROSS_3THPATH}$i" ]; then
        !            85:                        MK=$(eval echo "\$${i}_MAKE")
        !            86:                        env CFLAGS="-I${PKG}/include" LDFLAGS="-L${PKG}/lib" ${BUILD_SH} \
        !            87:                                $i $MK ${PKG} ${TARGET_BUILD} || Die "ERROR:: with $i packet!"
        !            88:                else
        !            89:                        Die "Error:: ${CROSS_PATH}$i not found!"
        !            90:                fi
        !            91:        done
1.6       misho      92: 
                     93: #      ${BUILD_SH} iftop ${CBUILD} ${PKG} ${TARGET_BUILD}
                     94: #      [ $? -ne 0 ] && exit 1
                     95: #      ${BUILD_SH} sudo ${CBUILD} ${PKG} ${TARGET_BUILD}
                     96: #      [ $? -ne 0 ] && exit 1
                     97: #      ${BUILD_SH} smartmontools ${CBUILD} ${PKG} ${TARGET_BUILD}
                     98: #      [ $? -ne 0 ] && exit 1
                     99: #      ${BUILD_SH} trafshow ${CBUILD} ${PKG} ${TARGET_BUILD}
                    100: #      [ $? -ne 0 ] && exit 1
1.5       misho     101: #      ${BUILD_SH} ipsec-tools ${CGBUILD} ${PKG} ${TARGET_BUILD}
                    102: #      [ $? -ne 0 ] && exit 1
                    103: #      ${BUILD_SH} dhcp ${CBUILD} ${PKG} ${TARGET_BUILD}
                    104: #      [ $? -ne 0 ] && exit 1
                    105: #      ${BUILD_SH} dhcping ${CBUILD} ${PKG} ${TARGET_BUILD}
                    106: #      [ $? -ne 0 ] && exit 1
                    107: #      ${BUILD_SH} miniupnpd ${CBUILD} ${PKG} ${TARGET_BUILD}
                    108: #      [ $? -ne 0 ] && exit 1
                    109: #      ${BUILD_SH} miniupnpc ${CGBUILD} ${PKG} ${TARGET_BUILD}
                    110: #      [ $? -ne 0 ] && exit 1
1.6       misho     111: #      ${BUILD_SH} ntp ${CBUILD} ${PKG} ${TARGET_BUILD}
                    112: #      [ $? -ne 0 ] && exit 1
1.5       misho     113: #      ${BUILD_SH} spawn-fcgi ${CBUILD} ${PKG} ${TARGET_BUILD}
                    114: #      [ $? -ne 0 ] && exit 1
                    115: #      ${BUILD_SH} lighttpd ${CBUILD} ${PKG} ${TARGET_BUILD}
1.4       misho     116: #      [ $? -ne 0 ] && exit 1
1.5       misho     117: #      ${BUILD_SH} libxml2 ${CBUILD} ${PKG} ${TARGET_BUILD}
1.4       misho     118: #      [ $? -ne 0 ] && exit 1
1.5       misho     119: #      ${BUILD_SH} php ${CBUILD} ${PKG} ${TARGET_BUILD}
                    120: #      [ $? -ne 0 ] && exit 1
                    121:        echo
1.3       misho     122: }
                    123: 
                    124: install_3th()
                    125: {
                    126:        LIBS="${ROMFS_USR2}/lib"
                    127:        LIBEXEC="${ROMFS_USR2}/libexec"
                    128:        BIN="${ROMFS_USR2}/bin"
                    129:        SBIN="${ROMFS_USR2}/sbin"
                    130:        ETC="${ROMFS_USR2}/etc"
                    131: 
1.6       misho     132:        echo "+++ Install ELWIX RomFS secondary firmware ... ${ROMFS_USR2}"
1.3       misho     133: 
                    134:        StripFiles \*.so\* ${PKG}/lib
                    135:        InstallFiles \*.so\* ${PKG}/lib $LIBS
                    136:        StripFiles \* ${PKG}/libexec
                    137:        InstallFiles \* ${PKG}/libexec $LIBEXEC
                    138:        StripFiles \* ${PKG}/bin
                    139:        InstallFiles \* ${PKG}/bin $BIN
                    140:        StripFiles \* ${PKG}/sbin
                    141:        InstallFiles \* ${PKG}/sbin $SBIN
                    142: 
                    143:        InstallFiles \* ${PKG}/etc $ETC
                    144: 
                    145:        chown -R root:wheel $SBIN $BIN $LIBDATA $LIBEXEC $LIBS
                    146: }
                    147: 
                    148: build_3th()
                    149: {
1.6       misho     150:        echo "+++ Build ELWIX Firmware secondary image ... ${ROMFS_USR2} --> ${REL}/${ROMFS_IMG2}"
1.3       misho     151: 
                    152:        cd ${ROMFS_USR2}
                    153:        pax -w -z -v -f${REL}/${ROMFS_IMG2} .
                    154:        cd -
1.2       misho     155: 
1.3       misho     156: # Stop using uzip fs
                    157: #      makefs -ominfree=0,bsize=8192,fsize=1024,optimization=space -s${ROMFS_SIZE2} \
                    158: #              ${REL}/${ROMFS_IMG2} ${ROMFS_USR2}
                    159: 
                    160: #      MDDEV=$(mdconfig -a -t vnode -f ${REL}/${ROMFS_IMG2});
                    161: #      tunefs -L elwixFirmware2 /dev/$MDDEV;
                    162: #      mdconfig -d -u $MDDEV;
                    163: 
                    164: #      mkuzip -s 8192 -o ${REL}/${ROMFS_IMG2}.uzip ${REL}/${ROMFS_IMG2};
                    165: #      mv ${REL}/${ROMFS_IMG2}.uzip ${REL}/${ROMFS_IMG2}
1.6       misho     166: 
                    167:        echo "+++ Complited ELWIX Firmware secondary image ... ${REL}/${ROMFS_IMG2}"
1.2       misho     168: }
                    169: 
                    170: ### main()
1.6.2.3   misho     171: if [ -n "${1}" ]; then
                    172:        rm ${PKG}/elwix.ver
                    173: fi
                    174: 
1.2       misho     175: if ! SnitVer ${PKG}/elwix.ver; then
1.5       misho     176:        clean_3th || exit 1
                    177:        compile_3th || exit 1
1.3       misho     178: 
1.5       misho     179:        install_3th || exit 1
                    180:        build_3th || exit 1
1.3       misho     181: 
                    182:        echo "ELWIX Platform:${PLATFORM} Version:${VERSION} TargetArch:${TARGET_ARCH}" >${PKG}/elwix.ver
1.2       misho     183: else
                    184:        echo "Skipped ELWIX 3th party build ..."
                    185: fi
                    186: 
                    187: echo "+++ Complete build ELWIX 3th party"

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>